#include <bits/stdc++.h>

using namespace std;

int check(int a, int b, int* N, int l)
{
    if(l == 0)
        return 1;
    if(l == 1)
        return 0;
    for(int i = a; i < b; i++)
        if(N[i] == 0)
            return 0;
    return 1;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, Q;
    cin >> n >> Q;
    int a, b;
    int l = n;

    int N[n];
    int R[Q];
    for(int i = 0; i < n; i++)
    {
        cin >> N[i];
        l -= N[i];
    }

    for(int i = 0; i < Q; i++)
    {
        cin >> a >> b;
        R[i] = check(a-1, b, N, l);
    }

    for(int i = 0; i < Q; i++)
        cout << R[i] << endl;

    return 0;
}